// Create XMLHttpRequest object
function xml_request()
{
   this.request = null;

   try { this.request = new XMLHttpRequest(); } catch(e) { // Mozilla, IE7
   try { this.request = new ActiveXObject("Msxml2.XMLHTTP"); } catch(e) {
   try { this.request = new ActiveXObject("Microsoft.XMLHTTP"); } catch(e) { return false; } } }

   this.request.onreadystatechange = track_status;
}

// ----------------------------------------------------------------------------
// POST
// param: url; array with values {key: value}
xml_request.prototype.post = function(url, array)
{
   this.request.open("POST", url, true);
   this.request.setRequestHeader("Content-Type","application/x-www-form-urlencoded");
   this.request.send(url_encode_data(array));
}

// ----------------------------------------------------------------------------
// string to use with POST requests (recursive!)
function url_encode_data(data, parent)
{
    if (!parent) parent = "";
    var query = [];

    if (data instanceof Object) {
        for (var k in data)
        {
           var key = parent ? parent+"["+k+"]" : k;

           query.push( data[k] instanceof Object ?
                         url_encode_data(data[k], key)
                       : encodeURIComponent(key) + "=" + encodeURIComponent(data[k]));
        }
        return query.join('&');
    } else {
        return encodeURIComponent(data);
    }
}

// ----------------------------------------------------------------------------
function track_status()
{
   dst = document.getElementById("ajax_status");
   if (!dst)
   {
      dst = document.createElement("div");
      dst.id = "ajax_status";
      document.body.appendChild(dst);
   }

   dst.style.visibility = 'visible';
   dst.style.opacity = 1;

//0 = uninitialized
//1 = loading
//2 = loaded
//3 = interactive
//4 = complete
   if (req.request.readyState < 4)
   {
      dst.style.backgroundColor = 'orange';
      dst.innerHTML = NETCAT_HTTP_REQUEST_SAVING;
   }
   else
   {
      var error_message = "";

      if (req.request.status=="200") // OK
      {
         var resp = req.request.responseText, result = {};

         try { eval("var result = "+resp); } catch (e) {}
         if (result.error)
         {
            alert(result.error);
            error_message = result.error;
         }
         else
         {
            dst.style.backgroundColor = '#39B54A';
            dst.innerHTML = NETCAT_HTTP_REQUEST_SAVED;
            setTimeout("fade_out('ajax_status')", 5000);
         }
      }
      else
      {
         error_message = req.request.status + ". " + req.request.statusText;
      }

      if (error_message)
      {
         dst.style.backgroundColor = '#CE0500';
         dst.innerHTML = NETCAT_HTTP_REQUEST_ERROR;
         dst.error = error_message;
         setTimeout("fade_out('ajax_status')", 15000);
      }

   }

}

function show_request_error()
{
   alert(document.getElementById('ajax_status').error);
}

var fade_intervals = [];
var isIE = navigator.userAgent.match(/MSIE/);

function fade_out(id)
{
   var dst = document.getElementById(id);

   if (isIE)
   {
      dst.style.filter="blendTrans(duration=1)";

      if (dst.filters.blendTrans.status != 2)
      {
         dst.filters.blendTrans.apply();
         dst.style.visibility="hidden";
         dst.filters.blendTrans.play();
      }
      return;
   }


   // hide if done with fading out
   if (dst.style.opacity==0)
   {
      clearInterval(fade_intervals[id]);
      fade_intervals[id] = null;
      dst.style.visibility='hidden';
      dst.style.opacity = 1;
      return;
   }

   dst.style.opacity = (Number(dst.style.opacity) - 0.05);

   // setup interval
   if (!fade_intervals[id]) fade_intervals[id] = setInterval("fade_out('"+id+"')",40);
}



// ----------------------------------------------------------------------------
// get data from forms
function save_form(form_object)
{
   // prepare request (GLOBAL!)
   req = new xml_request();
   if (!req.request) { alert("Sorry, it seems that your browser doesn't support XMLHttpRequest"); }


   if (form_object && !(form_object instanceof Object)) // maybe it's an ID
   {
      form_object = document.getElementById(form_object);
   }

   if (typeof form_object != 'object') // still don't know what it is, so save the FIRST form
   {
      form_object = document.getElementsByTagName("FORM")[0];
   }

   // collect form values into array
   var values = [];
   for (var i=0; i<form_object.length; i++)
   {
      var el = form_object.elements[i];
      if (el.tagName=="SELECT")
      {
         values[el.name] = el.options[el.options.selectedIndex].value;
      }
      else if (el.tagName=="INPUT" && (el.type=="checkbox" || el.type=="radio") && el.checked)
      {
         values[el.name] = el.value;
      }
      else if (el.name && el.value != undefined)
      {
         values[el.name] = el.value;
      }
   }

   values["NC_HTTP_REQUEST"] = 1; //  ,     Ajax   utf8

   req.post(form_object.action, values);
}


// ----------------------------------------------------------------------------
// capture keys
function keyhandler(e)
{
   if (window.event) { e = window.event; } // msie
   if (e.shiftKey && e.ctrlKey && e.keyCode==83) // ctrl+shift+s
   {
      save_form();
   }
}


window.onload = function() { document.body.onkeyup = keyhandler; }