<?php
/* $Id: function.inc.php,v 1.18 2006/08/11 12:08:48 kx Exp $ */

@include_once("../vars.inc.php");

require($ADMIN_FOLDER.'CheckUserFunctions.inc.php');


function LoadSettings ()
{
    global $db;
    global $IsInsideAdmin, $system_env;
    global $PROJECT_NAME, $VERSION_ID, $PLUGS_INSTALL_TYPE, $ANY_SYSTEM_MESSAGE, $SYSTEM_ID,$ADMIN_FOLDER;
    global $SPAM_FIELD, $SPAM_FROM, $SPAM_FROM_NAME, $NO_RIGHTS_MESSAGE, $PATCH_CHECK_DATE;
    global $LAST_PATCH, $LAST_LOCAL_PATCH, $SYSTEM_NAME, $SYSTEM_COLOR, $FILEMANAGER_SUB;
    global $HTTP_HOST, $REMOTE_ADDR, $HTTP_USER_AGENT;
    global $EDITOR_TYPE, $EMBED_EDITOR;


    $Array = $db->get_row('SELECT * FROM Settings',ARRAY_A);

    // probably system was not installed:
    if (!sizeof($Array))
    {
       if (file_exists("$GLOBALS[DOCUMENT_ROOT]/install/index.php"))
            { header("Location: /install/"); }
       else { print "<p><b>".NETCAT_ERROR_DB_CONNECT."</b></p>"; }

       die();
    }

    $PROJECT_NAME = $Array['ProjectName'];
    $PRODUCT_CODE = $Array['ProductNumber'];
    $FILEMANAGER_SUB = $Array['FileManagerSub'];
    $SYSTEM_ID = $Array['SystemID'];
    $VERSION_ID = $Array['VersionNumber'];
    $SPAM_FIELD = $Array['UserEmailField'];
    $SPAM_FROM = $Array['SpamFromEmail'];
    $SPAM_FROM_NAME = $Array['SpamFromName'];
    $EDITOR_TYPE = $Array['EditorType'];
    $EMBED_EDITOR = $Array['EmbedEditor'];

    switch ($SYSTEM_ID)
    {
        case "1":
            $SYSTEM_NAME = 'Small Business';
            $SYSTEM_COLOR = '#ff9900';
            break;
        case "2":
            $SYSTEM_NAME = 'Standard';
            $SYSTEM_COLOR = '#2690cf';
            break;
        case "3":
            $SYSTEM_NAME = 'Extra';
            $SYSTEM_COLOR = '#cc3300';
            break;
        case "4":
            $SYSTEM_NAME = 'Plus';
            $SYSTEM_COLOR = '#65C11A';
            break;
        case "5":
            $SYSTEM_NAME = 'Lite';
            $SYSTEM_COLOR = 'black';
            break;
        case "6":
            $SYSTEM_NAME = 'E-Commerce';
            $SYSTEM_COLOR = '#F07D22';
            break;
        case "7":
            $SYSTEM_NAME = 'SEO';
            $SYSTEM_COLOR = '#FDCC6D';
            break;
        case "8":
            $SYSTEM_NAME = 'Corporate';
            $SYSTEM_COLOR = '#525F67';
            break;
    }

    if ($Array['PlugsInstallType'])
    {
        $PLUGS_INSTALL_TYPE = "ext";
    }
    else
    {
        $PLUGS_INSTALL_TYPE = "int";
    }

    if ($SPAM_FIELD)
    {
        $SPAM_FIELD = $db->get_var("SELECT Field_Name FROM Field WHERE Field_ID=".($SPAM_FIELD+0));
    }
    else
    {
        $SPAM_FIELD = $db->get_var("SELECT a.Field_Name FROM Field AS a, System_Table AS b WHERE a.Format='email' AND a.System_Table_ID=b.System_Table_ID AND b.System_Table_Name='User'");
    }

    $LAST_LOCAL_PATCH = $db->get_var("SELECT Patch_Name FROM Patch ORDER BY Patch_Name DESC LIMIT 1");
    $LAST_LOCAL_PATCH += 0;

    list($LAST_PATCH,$PATCH_CHECK_DATE,$PATCH_CHECK_NEEDED) = $db->get_row("SELECT LastPatch,DATE_FORMAT(PatchCheck,'%d.%m.%Y'),DATE_ADD(PatchCheck,INTERVAL 7 DAY)<=CURDATE() FROM Settings",ARRAY_N);

    if (($PATCH_CHECK_NEEDED!="0" && $LAST_PATCH<=$LAST_LOCAL_PATCH) || $IsInsideAdmin)
    {
        // get module list in order to get correct patch
        require($ADMIN_FOLDER."modules/module_list.inc.php");

        $installed_modules = $db->get_results("SELECT Keyword
                                                 FROM Module
                                                WHERE Keyword IN ('".join("','", array_keys($real_modules))."')
                                               ", ARRAY_N);
        // flatten array:
        if ($installed_modules)
        {
           foreach ($installed_modules as $k=>$v) { $installed_modules[$k] = $v[0]; }
           $installed_modules = urlencode(join(',', $installed_modules));
        }

       $patch_aray=@file("http://www.netcat.ru/netcat/modules/default/patch.php?system=".$Array["SystemID"]."&version=".$Array["VersionNumber"]."&lastpatch=".$LAST_LOCAL_PATCH."&host=".$HTTP_HOST."&product=".$PRODUCT_CODE."&useremail=".$SPAM_FROM."&adminfolder=".$ADMIN_FOLDER."&userip=".$REMOTE_ADDR."&useragent=".urlencode($HTTP_USER_AGENT)."&modules=$installed_modules");
        if ($patch_aray)
        {
            $LAST_PATCH = join($patch_aray);
        }
        $db->query("UPDATE Settings SET PatchCheck=CURDATE(),LastPatch=".($LAST_PATCH+0));
    }

    $ANY_SYSTEM_MESSAGE = $db->get_var("SELECT count(*) FROM SystemMessage WHERE Checked=0");

    if ($LAST_LOCAL_PATCH)
    {
        $system_env['Powered']="NetCat/".$VERSION_ID.".".$LAST_LOCAL_PATCH." (".$SYSTEM_NAME.")";
    }
    else
    {
        $system_env['Powered']="NetCat/".$VERSION_ID." (".$SYSTEM_NAME.")";
    }
}

function BeginHtml ($title, $location, $HelpURL)
{
    # $title - ,     <title>
    global $PROJECT_NAME, $VERSION_ID, $SYSTEM_NAME, $SYSTEM_COLOR, $ADMIN_FOLDER, $ANY_SYSTEM_MESSAGE;
    global $perm, $REQUEST_URI;
    global $AUTHORIZATION_TYPE;
    global $main_section, $item_id;
    global $LAST_LOCAL_PATCH, $LAST_PATCH;
    global $DOMAIN_NAME, $NO_RIGHTS_MESSAGE;
    $NO_RIGHTS_MESSAGE = NETCAT_MODERATION_ERROR_NORIGHTS;
#	echo "<!DOCTYPE html PUBLIC \"-//W3C//DTD HTML 4.01 Transitional//EN\" \"http://www.w3.org/TR/html4/loose.dtd\">";
    ?>

<html lang='<?=MAIN_LANG?>' dir='<?=MAIN_DIR?>'>
<head>
	<title><?=($title?$title:"NetCat")?></title>
	<meta http-equiv='Content-Type' content='text/html; charset=<?=MAIN_ENCODING?>'>
	<link type='text/css' rel='Stylesheet' href='/netcat/admin/common/main.css'>
	<script type='text/javascript' src='/netcat/admin/common/main.js'></script>
<?
    if ($GLOBALS["AJAX_SAVER"])
    {
       print "<script type='text/javascript' src='/netcat/admin/common/formhandler.js'></script>\n";
       print "<script>
       var NETCAT_HTTP_REQUEST_SAVING = \"".str_replace('"', "&quot;", NETCAT_HTTP_REQUEST_SAVING)."\",
           NETCAT_HTTP_REQUEST_SAVED  = \"".str_replace('"', "&quot;", NETCAT_HTTP_REQUEST_SAVED )."\",
           NETCAT_HTTP_REQUEST_ERROR  = \"".str_replace('"', "&quot;", NETCAT_HTTP_REQUEST_ERROR )."\";
           </script>\n";
    }
?>
</head>
<body>
<table border=0 cellpadding=0 cellspacing=0 width=100% height=100%>
<tr><td>

<table width="100%" height="50" cellpadding=0 cellspacing=0 border=0>
<tr>
	<td width='30%' style='background-image: url(/netcat/admin/images/new_del.gif); background-position: right; background-repeat: no-repeat;'><table border=0 cellpadding=8 cellspacing=0><tr><td><a href=/netcat/admin/><img border=0 src=/netcat/admin/images/logo.gif></td><td nowrap><nobr><font size=-2 color=gray><?=BEGINHTML_VERSION?> <?=$VERSION_ID?><br><b><font size=-1 color=<?=$SYSTEM_COLOR?>><?=$SYSTEM_NAME?></td></tr></table></td></td>
	<td width=25%>&nbsp;
    <?php

	function set_url_var($var, $value, $url, $non_html_amp = false) {
		if ( !preg_match('#' . $var . '=#', $url) ) {	// append to end
			$url .= ( ( strpos($url, '?') != false ) ?  ( ( $non_html_amp ) ? '&' : '&amp;' ) : '?' ) . $var . '=' . $value;
		}
		else { 											// replace existing
			$pattern = '/(' . $var . '*)(=)([a-zA-Z0-9]*)/';
			$replacement = "\${1}=" . $value;
			$url = preg_replace($pattern, $replacement, $url);
		}
		return $url;
	}

	$mylang = Language_Show();

	define('LANG_VAR', 'NEW_AUTH_LANG');

	$sep = '';
	foreach ($mylang as $var => $value) {
  		if ($value == MAIN_NAME) {
			$str = $sep . '<span title="' . $value . '" class="ulanga">' . strtoupper(substr($value, 0, 3)) . '</span>';
			echo $str;
		}
		else {
			$myurl = set_url_var(LANG_VAR, $value, $_SERVER['REQUEST_URI']);
			$str = $sep . '<a href="' . $myurl . '">' . strtoupper(substr($value, 0, 2)) . '</a>';
			echo $str;
		}
		if (empty($sep)) {
		$sep = " | ";
		}
	}

    ?>
	</td>
	<td width=30><img src='/netcat/admin/images/emp.gif' width=30 height=0></td>
	<td width=45%>
		<table border=0 cellpadding=1 width=100%>
		<tr><td class=small  colspan=2><?=BEGINHTML_PROJECT?>: <b><?=$PROJECT_NAME?></b></td></tr>
		<tr><td class=small colspan=2>
<?=BEGINHTML_USER?>: <b>
    <?
    print $perm->getLogin()."</b>";
    if ($perm->isGuest())
    {
        print " (".BEGINHTML_PERM_GUEST.")";
    }
    else if ($perm->isDirector())
    {
        print " (".BEGINHTML_PERM_DIRECTOR.")";
    }
    else if ($perm->isSupervisor())
    {
        print " (".BEGINHTML_PERM_SUPERVISOR.")";
    }
    else if ($perm->isAnyCatalogueAdmin())
    {
        print " (".BEGINHTML_PERM_CATALOGUEADMIN.")";
    }
    else if ($perm->isAnySubdivisionAdmin())
    {
        print " (".BEGINHTML_PERM_SUBDIVISIONADMIN.")";
    }
    else if ($perm->isAnySubClassAdmin())
    {
        print " (".BEGINHTML_PERM_SUBCLASSADMIN.")";
    }
    ?>
		</td></tr>
		<tr>
			<td class=small><a href=/netcat/admin/unauth.php><img src=/netcat/admin/images/exit.gif border=0 alt='<?=BEGINHTML_LOGOUT?>' style='margin-left:10px;margin-right:5px;'></a></td>
			<td nowrap width=100%><a href=/netcat/admin/unauth.php style='font-size:xx-small;font-weight:bold;'>
	  <?

  echo(BEGINHTML_LOGOUT);
    ?>
			</a></td>
		</tr>
		</table>
	</td>
	</tr>
	</table>

</td></tr>
<tr><td bgcolor=#3c7ea4>
	<table width=100% cellpadding=0 cellspacing=0 border=0 bgcolor=#3c7ea4><tr><td>

		<table border=0 cellpadding=0 cellspacing=0><tr>

			<td nowrap style='padding:5px 13px 5px 20px; background:url(/netcat/admin/images/menu_div.gif) right top no-repeat;<? if ($main_section=="control") echo "background-color:#469EE1;"?>'><a  href='/netcat/admin/?main_section=control' style='text-decoration: none;color:white;font-size:95%;'><strong><?=BEGINHTML_SECTIONS_CONTROL?></strong></a></td>

			<td nowrap style='padding:5px 13px 5px 15px; background:url(/netcat/admin/images/menu_div.gif) right top no-repeat;<? if ($main_section=="settings") echo "background-color:#469EE1;"?>'><a  href='/netcat/admin/?main_section=settings' style='text-decoration: none;color:white;font-size:95%;'><strong><?=BEGINHTML_SECTIONS_SETTINGS?></strong></a></td>

			<td nowrap style='padding:5px 13px 5px 15px; background:url(/netcat/admin/images/menu_div.gif) right top no-repeat;<? if ($main_section=="report") echo "background-color:#469EE1;"?>'><a  href='/netcat/admin/?main_section=report' style='text-decoration: none;color:white;font-size:95%;'><strong><?=BEGINHTML_SECTIONS_REPORT?></strong></a></td>

			<td nowrap style='padding:5px 13px 5px 15px; background:url(/netcat/admin/images/menu_div.gif) right top no-repeat;<? if ($main_section=="support") echo "background-color:#469EE1;"?>'><a  href='/netcat/admin/?main_section=support' style='text-decoration: none;color:white;font-size:95%;'><strong><?=BEGINHTML_SECTIONS_SUPPORT?></strong></a></td>
			<td><img src='/netcat/admin/images/emp.gif' width=10 height=30></td>
		</tr></table>

	</td>
	<td align=right style='padding-right:15px;'><a href='/netcat/admin/patch/'><?=($LAST_LOCAL_PATCH<$LAST_PATCH?"<img alt='".BEGINHTML_ALARMPATCH."' title='".BEGINHTML_ALARMPATCH."' border=0 src='/netcat/admin/images/patch.gif' width=17 height=17 hspace=5>":"<img alt='".BEGINHTML_ALARMPACTCHOFF."' title='".BEGINHTML_ALARMPACTCHOFF."' border=0 src='/netcat/admin/images/patch_off.gif' width=17 height=17 hspace=5>")?></a><a href='/netcat/admin/report/system.php'><?=($ANY_SYSTEM_MESSAGE?"<img alt='".BEGINHTML_ALARMON."' title='".BEGINHTML_ALARMON."' border=0 src='/netcat/admin/images/alert.gif' hspace=5 width=17 height=17>":"<img alt='".BEGINHTML_ALARMOFF."' title='".BEGINHTML_ALARMOFF."' border=0 src='/netcat/admin/images/alert_off.gif' width=17 height=17 hspace=5>")?></a></td>
	</tr></table>
</td></tr>


    <?
    if ($title)
    {
        ?>
	<tr height=100%><td height=100% valign=top>
		<table border=0 cellpadding=0 cellspacing=0 width=100% height=100%>
		<tr><td width=25% bgcolor=#eeeeee height=100% valign=top>
		<table border=0 cellpadding=3 cellspacing=0 width=100% height=100%>
		<tr><td bgcolor=#eeeeee  valign=top height=100%>
		<table border=0 cellpadding=0 cellspacing=3>
        <tr><td><img src=/netcat/admin/images/emp.gif hspace=2 width=16 height=1></td><td></td></tr>

        <?
        switch ($main_section)
        {
            case "control":
                {
                    ?>

        <tr><td><img src=/netcat/admin/images/menuitem.gif hspace=2 width=16 height=16></td><td><font size=-1><b><?=SECTION_CONTROL_CONTENT?></b></td></tr>
        <tr><td></td><td><font size=-2><?=($item_id==1?"<b>":"")?><a href=/netcat/admin/catalogue/><?=SECTION_CONTROL_CONTENT_CATALOGUE?></a></td></tr>
        <tr><td></td><td><font size=-2><?=($item_id==2?"<b>":"")?><a href=/netcat/admin/subdivision/full.php><?=SECTION_CONTROL_CONTENT_FULL?></a></td></tr>
        <tr><td></td><td><font size=-2><?=($item_id==3?"<b>":"")?><a href=/netcat/admin/subdivision/favorites.php><?=SECTION_CONTROL_CONTENT_FAVORITES?></a></td></tr>
        <tr><td></td><td><font size=-2><?=($item_id==4?"<b>":"")?><a href=/netcat/admin/classificator.php><?=SECTION_CONTROL_CONTENT_CLASSIFICATOR?></a></td></tr>
        <tr><td><br></td></tr>

        <tr><td><img src=/netcat/admin/images/menuitem.gif hspace=2 width=16 height=16></td><td><font size=-1><b><?=SECTION_CONTROL_USER?></b></td></tr>
        <tr><td></td><td><font size=-2><?=($item_id==5?"<b>":"")?><a href=/netcat/admin/user/><?=SECTION_CONTROL_USER_LIST?></a></td></tr>
        <tr><td></td><td><font size=-2><?=($item_id==6?"<b>":"")?><a href=/netcat/admin/user/group.php><?=SECTION_CONTROL_USER_GROUP?></a></td></tr>
        <tr><td></td><td><font size=-2><?=($item_id==7?"<b>":"")?><a href=/netcat/admin/user/MessageToAll.php><?=SECTION_CONTROL_USER_MAIL?></a></td></tr>
        <tr><td><br></td></tr>

        <tr><td><img src=/netcat/admin/images/menuitem.gif hspace=2 width=16 height=16></td><td><font size=-1><b><?=SECTION_CONTROL_CLASS?></b></td></tr>
        <tr><td></td><td><font size=-2><?=($item_id==8?"<b>":"")?><a href=/netcat/admin/class/><?=SECTION_CONTROL_CLASS_LIST?></a></td></tr>
        <tr><td></td><td><font size=-2><?=($item_id==81?"<b>":"")?><a href=/netcat/admin/class/?phase=11><?=CONTROL_CLASS_CLASS_GROUPS?></a></td></tr>
        <tr><td></td><td><font size=-2><?=($item_id==9?"<b>":"")?><a href=/netcat/admin/class/import.php><?=SECTION_CONTROL_CLASS_IMPORT?></a></td></tr>
        <tr><td><br></td></tr>

        <tr><td><img src=/netcat/admin/images/menuitem.gif hspace=2 width=16 height=16></td><td><font size=-1><b><?=SECTION_CONTROL_TEMPLATE?></b></td></tr>
        <tr><td></td><td><font size=-2><?=($item_id==10?"<b>":"")?><a href=/netcat/admin/template/><?=SECTION_CONTROL_TEMPLATE_SHOW?></a></b></td></tr>
        <tr><td><br></td></tr>
                    <?
                }
                break;
            case "settings":
                {
                    ?>
        <tr><td><img src=/netcat/admin/images/menuitem.gif hspace=2 width=16 height=16></td><td><font size=-1><b><?=SECTION_SECTIONS_OPTIONS?></b></td></tr>
        <tr><td></td><td><font size=-2><?=($item_id==5?"<b>":"")?><a href=/netcat/admin/settings.php><?=SECTION_SECTIONS_OPTIONS_OPTIONS?></a></b></td></tr>
        <tr><td></td><td><font size=-2><?=($item_id==1?"<b>":"")?><a href=/netcat/admin/field/system.php><?=SECTION_SECTIONS_OPTIONS_SYSTEM?></a></td></tr>
        <tr><td></td><td><font size=-2><?=($item_id==6?"<b>":"")?><a href=/netcat/admin/redirect.php><?=SECTION_SECTIONS_OPTIONS_REDIRECTS?></a></b></td></tr>
<?/*?>        <tr><td></td><td><font size=-2><?=($item_id==7?"<b>":"")?><a href=/netcat/admin/update.php><?=SECTION_SECTIONS_OPTIONS_DBFLASH?></a></b></td></tr><?*/?>
<?/*?>        <tr><td></td><td><font size=-2><?=($item_id==2?"<b>":"")?><a href=/netcat/admin/systemclassificator.php><?=SECTION_SECTIONS_OPTIONS_SYSTEMLIST?></a></td></tr><?*/?>
        <tr><td><br></td></tr>

        <tr><td><img src=/netcat/admin/images/menuitem.gif hspace=2 width=16 height=16></td><td><font size=-1><b><?=SECTION_SECTIONS_INSTRUMENTS?></b></td></tr>
        <tr><td></td><td><font size=-2><?=($item_id==9?"<b>":"")?><a href=/netcat/admin/sql/><?=SECTION_SECTIONS_INSTRUMENTS_SQL?></a></td></tr>
        <tr><td></td><td><font size=-2><?=($item_id==2?"<b>":"")?><a href=/netcat/admin/crontasks.php><?=SECTION_SECTIONS_INSTRUMENTS_CRON?></a></td></tr>
        <tr><td></td><td><font size=-2><?=($item_id==10?"<b>":"")?><a href=/netcat/admin/html/><?=SECTION_SECTIONS_INSTRUMENTS_HTML?></a></td></tr>
        <tr><td></td><td><font size=-2><?=($item_id==11?"<b>":"")?><a href=/netcat/admin/template/converter.php><?=SECTION_SECTIONS_INSTRUMENTS_CONVERTER?></a></td></tr>
        <?
           if ($GLOBALS["SYSTEM_ID"]!=5) // not Lite Version
           {
              print "<tr><td></td><td><font size=-2>".
                     ($item_id==12?"<b>":"")."
                     <a href=/netcat/admin/siteinfo/admin.php>".
                     SECTION_SECTIONS_INSTRUMENTS_SITEINFO.
                     ($item_id==12?"</b>":"").
                     "</a></td></tr>";
           }
           else
           {
              print "<tr><td></td><td><font size=-2 color=gray>".
                     SECTION_SECTIONS_INSTRUMENTS_SITEINFO.
                     "</td></tr>";
           }
        ?>
        <tr><td><br></td></tr>

        <tr><td><img src=/netcat/admin/images/menuitem.gif hspace=2 width=16 height=16></td><td><font size=-1><b><?=SECTION_SECTIONS_MODDING?></b></td></tr>
        <tr><td></td><td><font size=-2><?=($item_id==3?"<b>":"")?><a href=/netcat/admin/modules/><?=SECTION_SECTIONS_MODDING_MODULES?></a></td></tr>
        <tr><td></td><td><font size=-2><?=($item_id==4?"<b>":"")?><a href=/netcat/admin/patch/><?=SECTION_SECTIONS_MODDING_PATCHES?></a></b></td></tr>
        <tr><td></td><td><font size=-2><?=($item_id==8?"<b>":"")?><a href=/netcat/admin/dump.php><?=SECTION_SECTIONS_MODDING_ARHIVES?></a></b></td></tr>
        <tr><td><br></td></tr>
                    <?
                }
                break;
            case "report":
                {
                    ?>
        <tr><td><img src=/netcat/admin/images/menuitem.gif hspace=2 width=16 height=16></td><td><font size=-1><b><?=SECTION_REPORTS?></b></td></tr>
        <tr><td></td><td><font size=-2><?=($item_id==1?"<b>":"")?><a href=/netcat/admin/report/><?=SECTION_REPORTS_TOTAL?></a></td></tr>
        <tr><td></td><td><font size=-2><?=($item_id==2?"<b>":"")?><a href=/netcat/admin/report/last.php><?=SECTION_REPORTS_LASTCHANGES?></a></td></tr>
        <tr><td></td><td><font size=-2><?=($item_id==3?"<b>":"")?><a href=/netcat/admin/report/system.php><?=SECTION_REPORTS_SYSMESSAGES?></a></td></tr>
        <tr><td><br></td></tr>

                    <?
                }
                break;
            case "support":
                {
                    ?>

        <tr><td><img src=/netcat/admin/images/menuitem.gif hspace=2 width=16 height=16></td><td><font size=-1><b><?=SECTION_SUPPORT?></b></td></tr>
        <tr><td></td><td><font size=-2><?=($item_id==1?"<b>":"")?><a href=/netcat/admin/support/><?=SECTION_SUPPORT_MAIL?></a></td></tr>
        <tr><td></td><td><font size=-2><?=($item_id==2?"<b>":"")?><a href=http://www.netcat.ru/forclients/register/><?=SECTION_SUPPORT_REGISTER?></a></td></tr>
        <tr><td></td><td><font size=-2><?=($item_id==3?"<b>":"")?><a href=http://www.netcat.ru/support/><?=SECTION_SUPPORT_SITE?></a></td></tr>
        <tr><td><br></td></tr>

                    <?
                }
                break;
        }

        ?>
</table>

</td></tr>
</table>
<br>

</td><td style='border-top: 1px solid #eeeeee;' valign=top>

<table border=0 cellpadding=3 cellspacing=1 width=100%><tr>
<td><br></td><td class=path width=100%><font size=-2><?= $location; ?></td></tr>
</table>
<table border=0 cellpadding=0 cellspacing=0 width=100%><tr><td bgcolor=eeeeee><img src=/netcat/admin/images/emp.gif width=1 height=1></td></tr></table>
<table border=0 cellpadding=10 cellspacing=0 width=100%><tr><td><font size=+1><?=$title?></td><td align=right><a href="<? print $HelpURL; ?>" target=help onclick="PopupWindow(this.href);return false;"><img border=0 src=/netcat/admin/images/help.gif width=16 height=16 align=absmiddle hspace=4 alt='<?=BEGINHTML_HELPNOTE?>'><font size=-2><b><?=BEGINHTML_HELPNOTE?></a></td></tr>
<tr><td colspan=2>
        <?
    }
    else
    {
        ?>
<tr height=100%><td height=100% valign=top>
	<table border=0 cellpadding=0 cellspacing=0 width=100%>
	<tr><td valign=top>

        <?
    }
}

function EndHtml ()
{
    if ($_POST["NC_HTTP_REQUEST"]) // saved via XMLHttpRequest
    {
       ob_end_clean();
       if ($GLOBALS["_RESPONSE"]) { print array2json($GLOBALS["_RESPONSE"]); }
       exit;
    }


    global $VERSION_ID,$db;

    if ($GLOBALS["AJAX_SAVER"])
    {
       print "<div class=save_hint>".NETCAT_HTTP_REQUEST_HINT."</div>";
    }

    ?>
		<br><br>
		</td></tr></table>
	</td></tr></table>
</td></tr>
<tr><td bgcolor=#dadada style='padding-left:14px;padding-right:30px;'>
	<table width=100% border=0 cellpadding=8 cellspacing=0>
	<tr>
		<td style='font-size:70%;'>&copy; 1999-<?=date("Y")?> <?=ENDHTML_AIST?> | <a href='/netcat/admin/about/' style='color:#505050;font-weight:bold; text-decoration:none;'><?=ENDHTML_ABOUT?></a></td>
		<td align=right style='font-size:70%;'><a href='mailto:support@netcat.ru' style='color:#505050;'>support@netcat.ru</a></td>
	</tr></table>
</td></tr>
</table>
</body>
</html>
    <?

}

$admin_mode = true;
if ($AUTHORIZATION_TYPE=='session')
{
    session_start();
}
//DBConnect();
LoadSettings();

Authorize (1);

#   
if ($_POST["NEW_AUTH_LANG"])
{
    $SETNEWLANG=$_POST["NEW_AUTH_LANG"];
}
elseif($_GET["NEW_AUTH_LANG"])
{
    $SETNEWLANG=$_GET["NEW_AUTH_LANG"];
}


if ($SETNEWLANG && $AUTH_USER_ID)
{
    $AUTH_LANG=$SETNEWLANG;
    //         
    //  Authorize --     if ($Language)

//    setcookie('AUTH_LANG', $AUTH_LANG, mktime(0,0,0,1,1,2037), "/");
    $db->query("UPDATE User SET Language='".$SETNEWLANG."' WHERE User_ID='".$AUTH_USER_ID."'");
}

if (preg_match("/^\w+$/", $AUTH_LANG))
{
    require_once($ADMIN_FOLDER."lang/".$AUTH_LANG.".php");
}
elseif(preg_match("/^\w+$/", $PHP_AUTH_LANG))
{
    require_once($ADMIN_FOLDER."lang/".$PHP_AUTH_LANG.".php");
}
elseif(preg_match("/^\w+$/", $_SESSION['User']['PHP_AUTH_LANG']))
{
    require_once($ADMIN_FOLDER."lang/".$_SESSION['User']['PHP_AUTH_LANG'].".php");
}
else
{
    if (!$PHP_AUTH_LANG)
    {
        $PHP_AUTH_LANG=NetCat_language_detect();
    }
    if ($PHP_AUTH_LANG)
    {
        require_once($ADMIN_FOLDER."lang/".$PHP_AUTH_LANG.".php");
    }
    else
    {
        require_once($ADMIN_FOLDER."lang/".$ADMIN_LANGUAGE.".php");
    }
}

if (!($perm->isSupervisor() || $perm->isManager() ||
$perm->isGuest() || $perm->isAnyCatalogueAdmin() ||
$perm->isAnySubdivisionAdmin() || $perm->isAnySubClassAdmin() ))
{
    BeginHtml (BEGINHTML_TITLE, BEGINHTML_TITLE, "http://".$DOC_DOMAIN."/admin/");
    print $NO_RIGHTS_MESSAGE;
    EndHtml ();
    exit;
}


#Variables filtering: GET,POST,COOKIE
function vars_secure()
{
    global $_GET,$_POST,$_COOKIE,$HTTP_COOKIE_VARS,$HTTP_GET_VARS,$HTTP_POST_VARS;

    $_GET = array_merge($HTTP_GET_VARS, $_GET);
    if( is_array($_GET) )
    {
        while( list($k, $v) = each($_GET) )
        {
            if( is_array($_GET[$k]) )
            {
                while( list($k2, $v2) = each($_GET[$k]) )
                {
                    $_GET[$k][$k2] = addslashes($v2);
                }
                @reset($_GET[$k]);
            }
            else
            {
                $_GET[$k] = addslashes($v);
            }
        }
        @reset($_GET);
    }

    $_POST = array_merge($HTTP_POST_VARS, $_POST);
    if( is_array($_POST) )
    {
        while( list($k, $v) = each($_POST) )
        {
            if( is_array($_POST[$k]) )
            {
                while( list($k2, $v2) = each($_POST[$k]) )
                {
                    $_POST[$k][$k2] = addslashes($v2);
                }
                @reset($_POST[$k]);
            }
            else
            {
                $_POST[$k] = addslashes($v);
            }
        }
        @reset($_POST);
    }

    $_COOKIE = array_merge($HTTP_COOKIE_VARS, $_COOKIE);
    if( is_array($_COOKIE) )
    {
        while( list($k, $v) = each($_COOKIE) )
        {
            if( is_array($_COOKIE[$k]) )
            {
                while( list($k2, $v2) = each($_COOKIE[$k]) )
                {
                    $_COOKIE[$k][$k2] = addslashes($v2);
                }
                @reset($_COOKIE[$k]);
            }
            else
            {
                $_COOKIE[$k] = addslashes($v);
            }
        }
        @reset($_COOKIE);
    }
}


function array2json($array)
{
   $ret_values = array();
   foreach ($array as $k=>$v)
   {
      $ret_values[] = (is_numeric($k) ? $k : "\"".addcslashes($k, '"')."\"") . ":" .
                      (is_array($v) ? array2json($v) :
                      (is_numeric($v) ? $v : "\"".addcslashes($v, '"')."\""));
   }
   return "{" . join(",",  $ret_values) . "}";
}

?>