<?php
/* $Id: s_loadenv.inc.php,v 1.14 2006/08/21 14:45:46 kx Exp $ */

function LoadEnv() {
   global $db;
   global $MODULE_VARS;
   global $admin_mode;
   global $catalogue, $sub, $cc;
   global $current_catalogue;
   global $current_sub;
   global $current_cc;
   global $cc_array;

   global $system_table_fields, $user_table_mode, $user_table_env, $system_env;
   global $parent_sub_tree, $sub_level_count;

   LoadSystemSettings ();

   // Define $catalogue, $sub and $cc

   if (!$catalogue) {
      $catalogue = $db->get_var("SELECT Catalogue_ID FROM Catalogue ORDER BY Priority LIMIT 1");
      if (!$catalogue) exit;
   }

   if (!$sub) {
      $sub = $db->get_var("SELECT Title_Sub_ID FROM Catalogue WHERE Catalogue_ID='".$catalogue."'");

      if (!$sub) exit;
   }

   if (!$cc) {
      if (!$admin_mode) $checked_only = " AND Checked=1";
      $cc = $db->get_var("SELECT Sub_Class_ID FROM Sub_Class WHERE Subdivision_ID=".$sub.$checked_only." ORDER BY Priority LIMIT 1");
   }

   // Load all sub_class id's into array

   if (!$cc_array || !is_array($cc_array))
   {
      $cc_array = array();

      if ($res = $db->get_results("SELECT Sub_Class_ID, Checked
                                     FROM Sub_Class
                                    WHERE Subdivision_ID='$sub'
                                 ORDER BY Priority", ARRAY_N))
      {
         foreach ($res as $row)
         {
            $cc_array[] = $row[0];
         }
      }
   }

   // Load system table field info

   $res = $db->get_results("SELECT b.System_Table_Name   as system_table_name,
                                    a.Field_ID           as id,
                                    a.Field_Name         as name,
                                    a.TypeOfData_ID      as type,
                                    a.Inheritance        as inheritance,
                                    a.Format             as format
                               FROM Field AS a,
                                    System_Table AS b
                              WHERE a.System_Table_ID=b.System_Table_ID
                              ORDER BY a.System_Table_ID,
                                    a.Priority", ARRAY_A);
   foreach ($res as $row)
   {
      $system_table_fields[$row['system_table_name']][] = $row;
   }
   // ---------------------^

   // Load environment

   $sub_level_count = 0;

   $current_catalogue = ConvertSystemVars($current_catalogue, "Catalogue");

   $current_sub = InheritSubdivisionEnv($sub);
   $current_cc = InheritSubClassEnv($cc);

   if ($current_sub['Subdivision_ID']==$MODULE_VARS['auth'][USER_MODIFY_SUB] || $current_cc['System_Table_ID']) $user_table_mode = true; else $user_table_mode = false;
   if ($user_table_mode) $user_table_env = LoadSystemTableClass("User");

   $parent_sub_tree[$sub_level_count]["Subdivision_Name"] = $current_catalogue["Catalogue_Name"];
   $parent_sub_tree[$sub_level_count]["Hidden_URL"] = "/";

}

function InheritCatalogueEnv ($catalogue) {
   global $db, $HTTP_FILES_PATH, $system_table_fields;

   $catalogue_env = $db->get_row("SELECT * FROM Catalogue WHERE Catalogue_ID='".$catalogue."'",ARRAY_A);

   $catalogue_env = ConvertSystemVars($catalogue_env,"Catalogue");

   return $catalogue_env;
}

function InheritSubdivisionEnv ($sub) {
   global $db;
   global $system_table_fields, $HTTP_FILES_PATH;
   global $parent_sub_tree, $sub_level_count, $current_catalogue;

   //$sub_env = $db->get_row("SELECT * FROM Subdivision WHERE Subdivision_ID='$sub'",ARRAY_A); }

   $sub_env = GetSubdivisionByID($sub);
   $sub_env = ConvertSystemVars($sub_env,"Subdivision");

   $sub_level_count = 0;
   $parent_sub_tree[] = "";

   $parent_sub_tree[$sub_level_count] = $sub_env;
   $sub_level_count++;

   $parent_sub = $sub_env["Parent_Sub_ID"];
   while ($parent_sub)
   {
//      $parent_sub_env = $db->get_row("SELECT * FROM Subdivision WHERE Subdivision_ID='".$parent_sub."'",ARRAY_A);
      $parent_sub_env = GetSubdivisionByID($parent_sub);

      $parent_sub_env = ConvertSystemVars($parent_sub_env,"Subdivision");

      if (!$sub_env["Template_ID"]) $sub_env["Template_ID"] = $parent_sub_env["Template_ID"];
      if (!$sub_env["Read_Access_ID"]) $sub_env["Read_Access_ID"] = $parent_sub_env["Read_Access_ID"];
      if (!$sub_env["Write_Access_ID"]) $sub_env["Write_Access_ID"] = $parent_sub_env["Write_Access_ID"];
      if (!$sub_env["Edit_Access_ID"]) $sub_env["Edit_Access_ID"] = $parent_sub_env["Edit_Access_ID"];
      if (!$sub_env["Subscribe_Access_ID"]) $sub_env["Subscribe_Access_ID"] = $parent_sub_env["Subscribe_Access_ID"];
      if (!$sub_env["Moderation_ID"]) $sub_env["Moderation_ID"] = $parent_sub_env["Moderation_ID"];

      $parent_sub_tree[$sub_level_count] = $parent_sub_env;
      $sub_env = InheritSystemFields ("Subdivision",$parent_sub_tree[$sub_level_count],$sub_env);

      $sub_level_count++;

      $parent_sub = $parent_sub_env["Parent_Sub_ID"];
   }

   if (!$current_catalogue)
   $catalogue_env = InheritCatalogueEnv ($sub_env["Catalogue_ID"]);
   else
   $catalogue_env = $current_catalogue;

   $sub_env = InheritSystemFields ("Catalogue",$catalogue_env,$sub_env);

   if (!$sub_env["Template_ID"]) $sub_env["Template_ID"] = $catalogue_env["Template_ID"];
   if (!$sub_env["Read_Access_ID"]) $sub_env["Read_Access_ID"] = $catalogue_env["Read_Access_ID"];
   if (!$sub_env["Write_Access_ID"]) $sub_env["Write_Access_ID"] = $catalogue_env["Write_Access_ID"];
   if (!$sub_env["Edit_Access_ID"]) $sub_env["Edit_Access_ID"] = $catalogue_env["Edit_Access_ID"];
   if (!$sub_env["Subscribe_Access_ID"]) $sub_env["Subscribe_Access_ID"] = $catalogue_env["Subscribe_Access_ID"];
   if (!$sub_env["Moderation_ID"]) $sub_env["Moderation_ID"] = $catalogue_env["Moderation_ID"];

   $parent_sub_tree[$sub_level_count] = $catalogue_env;

   return $sub_env;
}

function InheritSystemFields ($system_table_name, $parent_array, $child_array) {
   global $system_table_fields;

   for ($i=0;$i<count($system_table_fields[$system_table_name]);$i++) {
      if ($system_table_fields[$system_table_name][$i]['inheritance']) {
         if ($child_array[$system_table_fields[$system_table_name][$i]['name']]=="") {
            $child_array[$system_table_fields[$system_table_name][$i]['name']] = $parent_array[$system_table_fields[$system_table_name][$i]['name']];
         }
      }
   }

   return $child_array;
}

function InheritSubClassEnv ($cc) {
   global $db, $current_sub, $cc_in_sub;
//   global $_cache;

   if ($cc) {

      // check in the $cc_in_sub global array (filled in e404)
      foreach ((array)$cc_in_sub as $row)
      {
         if ($row["Sub_Class_ID"]==$cc) // we've found it!
         {
            $cc_env = $row;
            break;
         }
      }

      if (!$cc_env)
      {
         $cc_env = $db->get_row("SELECT * FROM Sub_Class WHERE Sub_Class_ID='".$cc."'",ARRAY_A);
      }


      if ($cc_env)
      {
         // inherit from Class
         $class_env = $db->get_row("SELECT * FROM Class WHERE Class_ID='".$cc_env["Class_ID"]."'",ARRAY_A);

         while (list($key, $val) = each($class_env))
         if ($cc_env[$key]=="") $cc_env[$key] = $val;

         if ($cc_env["NL2BR"] == -1) $cc_env["NL2BR"] = $class_env["NL2BR"];
         if ($cc_env["AllowTags"] == -1) $cc_env["AllowTags"] = $class_env["AllowTags"];
      }
   }

   // inherit from Subdivision
   $sub_env = $current_sub;

   if (!$cc_env["Read_Access_ID"]) $cc_env["Read_Access_ID"] = $sub_env["Read_Access_ID"];
   if (!$cc_env["Write_Access_ID"]) $cc_env["Write_Access_ID"] = $sub_env["Write_Access_ID"];
   if (!$cc_env["Edit_Access_ID"]) $cc_env["Edit_Access_ID"] = $sub_env["Edit_Access_ID"];
   if (!$cc_env["Subscribe_Access_ID"]) $cc_env["Subscribe_Access_ID"] = $sub_env["Subscribe_Access_ID"];
   if (!$cc_env["Moderation_ID"]) $cc_env["Moderation_ID"] = $sub_env["Moderation_ID"];

   return $cc_env;
}

function ListClassVars ($cc,$user_table_mode) {
   global $db, $MODULE_VARS, $DOMAIN_NAME;
   global $cc_in_sub;

   $fields = "Catalogue_ID,Read_Access_ID,Write_Access_ID,Edit_Access_ID,Subscribe_Access_ID,Moderation_ID";

   if (!$user_table_mode) {

      $Array = array(); // :-D

      if ($cc_in_sub)
      {
         foreach ($cc_in_sub as $row)
         {
            if ($row["Sub_Class_ID"]==$cc)
            {
               $Array = $row; break;
            }
         }
      }

      if (!$Array) $Array = $db->get_row("SELECT * FROM Sub_Class WHERE Sub_Class_ID='".$cc."'",ARRAY_A);

      $class_cond = "Class_ID=".$Array["Class_ID"];
   } else {
      $user_table_id = $db->get_var("SELECT System_Table_ID FROM System_Table WHERE System_Table_Name='User'");

      $class_cond = "System_Table_ID=".$user_table_id;
      $Array["System_Table_ID"] = $user_table_id;
      $Array["Subdivision_ID"] = $MODULE_VARS[auth][USER_LIST_SUB];
      $Array["EnglishName"] = $MODULE_VARS[auth][USER_KEYWORD];
   }


	//  ,  $cc  
	if (!$Array) {
		echo "<font color=red>Incorrect \$cc</font>";
		return NULL;
	}

   // inherit from Class
   $class_env = $db->get_row("SELECT * FROM Class WHERE ".$class_cond,ARRAY_A);

   while (list($key, $val) = each($class_env))
   if ($Array[$key]=="") $Array[$key] = $val;

   if ($Array["NL2BR"] == -1) $Array["NL2BR"] = $class_env["NL2BR"];
   if ($Array["AllowTags"] == -1) $Array["AllowTags"] = $class_env["AllowTags"];

   if ($Array["Subdivision_ID"]) {

      $parent_sub = $Array["Subdivision_ID"];

      $Domain = $db->get_var("SELECT b.Domain FROM Subdivision AS a, Catalogue AS b WHERE a.Catalogue_ID=b.Catalogue_ID AND a.Subdivision_ID=".$parent_sub);
      $HiddenHost = ($Domain?(strchr($Domain,".")?$Domain:$Domain.".".$DOMAIN_NAME):$DOMAIN_NAME);


      while ($parent_sub) {
//         $ParentArray = $db->get_row("SELECT ".$fields.",Parent_Sub_ID,Subdivision_Name,Hidden_URL FROM Subdivision WHERE Subdivision_ID='".$parent_sub."'",ARRAY_A);
         $ParentArray = GetSubdivisionByID($parent_sub);

         if ($Array["Subdivision_ID"]==$parent_sub) {
            $Array["Subdivision_Name"]=$ParentArray["Subdivision_Name"];
            $Array["Hidden_URL"]=$ParentArray["Hidden_URL"];
            $Array["Hidden_Host"]=$HiddenHost;
         }

         if (!$Array["Read_Access_ID"]) $Array["Read_Access_ID"] = $ParentArray["Read_Access_ID"];
         if (!$Array["Write_Access_ID"]) $Array["Write_Access_ID"] = $ParentArray["Write_Access_ID"];
         if (!$Array["Edit_Access_ID"]) $Array["Edit_Access_ID"] = $ParentArray["Edit_Access_ID"];
         if (!$Array["Subscribe_Access_ID"]) $Array["Subscribe_Access_ID"] = $ParentArray["Subscribe_Access_ID"];
         if (!$Array["Moderation_ID"]) $Array["Moderation_ID"] = $ParentArray["Moderation_ID"];

         $parent_sub = $ParentArray["Parent_Sub_ID"];
      }

      if (!$Array["Catalogue_ID"]) $Array["Catalogue_ID"] = $ParentArray["Catalogue_ID"];
   }

   if ($Array["Catalogue_ID"]==$GLOBALS["catalogue"])
   {
      $ParentArray = $GLOBALS["current_catalogue"];
   }
   else
   {
      $ParentArray = $db->get_row("SELECT ".$fields." FROM Catalogue WHERE Catalogue_ID=".$Array["Catalogue_ID"],ARRAY_A);
   }


   if (!$Array["Read_Access_ID"]) $Array["Read_Access_ID"] = $ParentArray["Read_Access_ID"];
   if (!$Array["Write_Access_ID"]) $Array["Write_Access_ID"] = $ParentArray["Write_Access_ID"];
   if (!$Array["Edit_Access_ID"]) $Array["Edit_Access_ID"] = $ParentArray["Edit_Access_ID"];
   if (!$Array["Subscribe_Access_ID"]) $Array["Subscribe_Access_ID"] = $ParentArray["Subscribe_Access_ID"];
   if (!$Array["Moderation_ID"]) $Array["Moderation_ID"] = $ParentArray["Moderation_ID"];

   return $Array;
}

function InheritTemplateEnv ($template)
{
   global $db, $HTTP_FILES_PATH;
   global $system_table_fields, $db;

   $template += 0;
   $field_6_types = array();

   for($i=0;$i<count($system_table_fields['Template']);$i++)
   {
      if ($system_table_fields['Template'][$i]['type']==6)
      {
         $field_6_types[$i] = $system_table_fields['Template'][$i]['name'];
         $field_string .= "IF(".$system_table_fields['Template'][$i]['name']."<>'',CONCAT('".$HTTP_FILES_PATH.$system_table_fields['Template'][$i]['id']."_',Template_ID,RIGHT(SUBSTRING_INDEX(".$system_table_fields['Template'][$i]['name'].",':',1), LOCATE('.',REVERSE(SUBSTRING_INDEX(".$system_table_fields['Template'][$i]['name'].",':',1))))),'') AS ".$system_table_fields['Template'][$i]['name'].",";
      }
      else
      $field_string .= $system_table_fields['Template'][$i]['name'].",";
   }

   $template_env = $db->get_row("SELECT {$field_string}
                                        Parent_Template_ID,
                                        Header,
                                        Footer,
                                        Settings
                                   FROM Template
                                   WHERE Template_ID='{$template}'",ARRAY_A);

   foreach ($field_6_types as $tmp_key => $tmp_value)
   {
      $q = $db->get_row("SELECT Virt_Name, Real_Name
                           FROM Filetable
                          WHERE File_Path = '/t/'
                            AND Message_ID = '{$template}'
                            AND Field_ID = '{$system_table_fields['Template'][$tmp_key]['id']}'",
      ARRAY_N);

      if ($db->num_rows != 0)
      {
         list($Virt_Name, $Real_Name) = $q;
         $template_env[$tmp_value] = $HTTP_FILES_PATH."t/"."h_".$Virt_Name;
         $template_env["{$tmp_value}_url"] = $HTTP_FILES_PATH."t/".$Virt_Name;
      }
      else // old-style filesystem
      {
         $template_env["{$tmp_value}_url"] = $template_env[$tmp_value];
      }

   }


   $parent_template = $template_env["Parent_Template_ID"];
   while ($parent_template)
   {
      $parent_template_env = $db->get_row("SELECT {$field_string}Parent_Template_ID,Header,Footer,Settings FROM Template WHERE Template_ID='{$parent_template}'",ARRAY_A);

      $parent_template = $template_env["Parent_Template_ID"];

      if (!$template_env["Header"])
      {
         $template_env["Header"] = $parent_template_env["Header"];
      }
      if (!$template_env["Footer"])
      {
         $template_env["Footer"] = $parent_template_env["Footer"];
      }

      $template_env["Header"] = str_replace ("%Header",$parent_template_env["Header"], $template_env["Header"]);
      $template_env["Footer"] = str_replace ("%Footer",$parent_template_env["Footer"], $template_env["Footer"]);

      $template_env["Settings"] .= $parent_template_env["Settings"].$template_env["Settings"];

      $template_env = InheritSystemFields("Template",$parent_template_env,$template_env);
      $parent_template = $parent_template_env["Parent_Template_ID"];
   }

   for ($i=0;$i<count($system_table_fields['Template']);$i++)
   {
      $template_env["Header"] = str_replace("%".$system_table_fields['Template'][$i]['name'],$template_env[$system_table_fields['Template'][$i]['name']],$template_env["Header"]);
      $template_env["Footer"] = str_replace("%".$system_table_fields['Template'][$i]['name'],$template_env[$system_table_fields['Template'][$i]['name']],$template_env["Footer"]);
   }

   return $template_env;
}

function LoadSystemTableClass ($SystemTableName) {
   global $db;

   $table_env = $db->get_row("SELECT * FROM System_Table AS a, Class AS b WHERE a.System_Table_ID=b.System_Table_ID AND a.System_Table_Name='".$SystemTableName."'",ARRAY_A);

   return $table_env;
}

function LoadSystemSettings () {
   global $db, $system_env;

   $system_env = $db->get_row("SELECT * FROM Settings LIMIT 1",ARRAY_A);

   if ($system_env['UserEmailField']) {
       $system_env['UserEmailField'] = $db->get_var("SELECT Field_Name FROM Field WHERE Field_ID=".$system_env['UserEmailField']);
   }

   switch ($system_env['SystemID']) {
      case "1": $SYSTEM_NAME = "Small Business"; break;
      case "2": $SYSTEM_NAME = "Standard"; break;
      case "3": $SYSTEM_NAME = "Extra"; break;
      case "4": $SYSTEM_NAME = "Plus"; break;
   }

   $LAST_LOCAL_PATCH = $db->get_var("SELECT Patch_Name FROM Patch ORDER BY Patch_Name DESC LIMIT 1");
   $LAST_LOCAL_PATCH += 0;

   if ($LAST_LOCAL_PATCH) {
      $system_env['Powered']="NetCat/".$system_env['VersionNumber'].".".$LAST_LOCAL_PATCH." (".$SYSTEM_NAME.")";
   } else {
      $system_env['Powered']="NetCat/".$system_env['VersionNumber']." (".$SYSTEM_NAME.")";
   }

   Header("X-Powered-By: ".$system_env['Powered']);

   return;
}


function GetCatalougeLanguge($catid=0) {
   global $db, $catalogue, $current_catalogue;
   if (!$catalogue) $catalogue = $catid;

   // return current catalogue language
   if (is_array($current_catalogue) && ($current_catalogue["Catalogue_ID"]==$catid || $catid===0))
   {
      return $current_catalogue["Language"];
   }

   $res = $db->get_var("SELECT Language FROM Catalogue WHERE Catalogue_ID='".$catalogue."' LIMIT 1");

   if ($res) {
      return($res);
   } else {
      return(false);
   }
}


function LoadModuleEnv () {
   global $db, $Catalouge_ID, $catalogue, $MODULE_VARS, $MODULE_FOLDER, $INCLUDE_FOLDER;

   require_once $INCLUDE_FOLDER."s_common.inc.php";

   $lang = GetCatalougeLanguge();

   $res = $db->get_results("SELECT Keyword,Parameters FROM Module ORDER BY Module_ID",ARRAY_N);

   foreach ($res as $row) {

      list($keyword,$params) = $row;

      // parse module params
      $query_string = str_replace("\n","&",$params);
      parse_str ($query_string, $MODULE_VARS[$keyword]);

      while (list($var,$val)=each($MODULE_VARS[$keyword]))
      $MODULE_VARS[$keyword][$var] = trim($val);

      // include language file
      if (is_file($MODULE_FOLDER.$keyword."/".$lang.".lang.php")) {
         require_once($MODULE_FOLDER.$keyword."/".$lang.".lang.php");
      } else {
         require_once($MODULE_FOLDER.$keyword."/en.lang.php");
      }

      // include the module itself
      require_once $MODULE_FOLDER.$keyword."/function.inc.php";

   }
}

function ConvertSystemVars ($env_array,$table_name) {
   global $system_table_fields;
   global $HTTP_FILES_PATH, $db;

   for ($i=0;$i<count($system_table_fields[$table_name]);$i++) {
      $field_id = $system_table_fields[$table_name][$i]['id'];
      $field_name = $system_table_fields[$table_name][$i]['name'];
      $field_type = $system_table_fields[$table_name][$i]['type'];
      $field_format = $system_table_fields[$table_name][$i]['format'];

      if ($env_array[$field_name]) {
         switch ($field_type) {
            case 4: {
               $listname = $db->get_var("SELECT ".$field_format."_Name FROM Classificator_".$field_format." WHERE ".$field_format."_ID=".$env_array[$field_name]);

               $env_array[$field_name."_id"] = $env_array[$field_name];
               $env_array[$field_name] = $listname;
            } break;
            case 6: {
               list($filename,$filetype,$filesize) = split(":",$env_array[$field_name]);
               $fileext = substr($filename,strrpos($filename,"."));

               $env_array[$field_name."_name"] = $filename;
               $env_array[$field_name."_size"] = $filesize;
               $env_array[$field_name."_type"] = $filetype;

               $q = $db->get_row("SELECT Virt_Name, File_Path FROM Filetable WHERE Message_ID = '{$env_array[$table_name."_ID"]}' AND Field_ID = '{$field_id}' AND Real_Name = '{$filename}' LIMIT 1", ARRAY_N);

               if ($db->num_rows != 0)
               {
                  list($Virt_Name, $File_Path) = $q;
                  $env_array[$field_name] = $HTTP_FILES_PATH.ltrim($File_Path, '/')."h_".$Virt_Name;
                  $env_array["{$field_name}_url"] = $HTTP_FILES_PATH.ltrim($File_Path, '/').$Virt_Name;
               }
               else
               {
                  $env_array[$field_name] = $HTTP_FILES_PATH.$field_id."_".$env_array[$table_name."_ID"].$fileext;
                  $env_array["{$field_name}_url"] = $env_array[$field_name];
               }

            } break;
            case 8: {
               $env_array[$field_name."_year"] = substr($env_array[$field_name],0,4);
               $env_array[$field_name."_month"] = substr($env_array[$field_name],5,2);
               $env_array[$field_name."_day"] = substr($env_array[$field_name],8,2);
               $env_array[$field_name."_hours"] = substr($env_array[$field_name],11,2);
               $env_array[$field_name."_minutes"] = substr($env_array[$field_name],14,2);
               $env_array[$field_name."_seconds"] = substr($env_array[$field_name],17,2);
            } break;
         }
      }
   }

   return $env_array;
}

function LoadUserEnv () {
   global $db, $AUTH_USER_ID, $current_user;

   // we've got already user info
   if (!$current_user["User_ID"])
   $current_user =$db->get_row("SELECT * FROM User WHERE User_ID='".$AUTH_USER_ID."'",ARRAY_A);

   $current_user = ConvertSystemVars($current_user,"User");
}

?>